summaryrefslogtreecommitdiff
path: root/tests/fsck-tests
diff options
context:
space:
mode:
authorQu Wenruo <quwenruo@cn.fujitsu.com>2014-12-25 09:32:15 +0800
committerDavid Sterba <dsterba@suse.cz>2015-01-14 18:34:18 +0100
commite6bc739148adf8cd8edd18de7c1e36aad31a6ac6 (patch)
tree6c31eb57df7419c9a7ee282e9e060a4d7cc4921d /tests/fsck-tests
parent21afe4a316eb82d437b1cb2b8dab69c8b06a74bf (diff)
btrfs-progs: Move extent tree rebuild test to its dir
Move extent tree rebuild teset to its dir. Signed-off-by: Qu Wenruo <quwenruo@cn.fujitsu.com> Signed-off-by: David Sterba <dsterba@suse.cz>
Diffstat (limited to 'tests/fsck-tests')
-rwxr-xr-xtests/fsck-tests/013-extent-tree-rebuild/test.sh47
1 files changed, 47 insertions, 0 deletions
diff --git a/tests/fsck-tests/013-extent-tree-rebuild/test.sh b/tests/fsck-tests/013-extent-tree-rebuild/test.sh
new file mode 100755
index 00000000..ce51e07d
--- /dev/null
+++ b/tests/fsck-tests/013-extent-tree-rebuild/test.sh
@@ -0,0 +1,47 @@
+#!/bin/bash
+
+source $top/tests/common
+
+if [ -z $TEST_DEV ]; then
+ echo " [NOTRUN] extent tree rebuild, need TEST_DEV variant"
+ exit 0
+fi
+
+if [ -z $TEST_MNT ];then
+ echo " [NOTRUN] extent tree rebuild, need TEST_MNT variant"
+ exit 0
+fi
+
+# test whether fsck can rebuild a corrupted extent tree
+test_extent_tree_rebuild()
+{
+ echo " [TEST] extent tree rebuild"
+ $top/mkfs.btrfs -f $TEST_DEV >> /dev/null 2>&1 || _fail "fail to mkfs"
+
+ run_check mount $TEST_DEV $TEST_MNT
+ cp -aR /lib/modules/`uname -r`/ $TEST_MNT 2>&1
+
+ for i in `seq 1 100`;do
+ $top/btrfs sub snapshot $TEST_MNT \
+ $TEST_MNT/snapaaaaaaa_$i >& /dev/null
+ done
+ run_check umount $TEST_DEV
+
+ # get extent root bytenr
+ extent_root_bytenr=`$top/btrfs-debug-tree -r $TEST_DEV | \
+ grep extent | awk '{print $7}'`
+ if [ -z $extent_root_bytenr ];then
+ _fail "fail to get extent root bytenr"
+ fi
+
+ # corrupt extent root node block
+ run_check $top/btrfs-corrupt-block -l $extent_root_bytenr \
+ -b 4096 $TEST_DEV
+
+ $top/btrfs check $TEST_DEV >& /dev/null && \
+ _fail "btrfs check should detect failure"
+ run_check $top/btrfs check --init-extent-tree $TEST_DEV
+ run_check $top/btrfs check $TEST_DEV
+}
+
+test_extent_tree_rebuild